2017-11-19 10:13 UTC

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0003931Kali Linux[All Projects] Kali Package Bugpublic2017-04-11 09:13
Reporterj-marz 
Assigned To 
PriorityhighSeveritymajorReproducibilityalways
StatusclosedResolutionfixed 
Product Version 
Target VersionFixed in Version2017.1 
Summary0003931: Arachni load error
DescriptionReceive the following error when trying to run Arachni from cli

root@kali:~# arachni
/usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj-2.15.0/lib/oj.rb:42:in `require': /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj-2.15.0/lib/oj/oj.so: wrong ELF class: ELFCLASS64 - /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj-2.15.0/lib/oj/oj.so (LoadError)
    from /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj-2.15.0/lib/oj.rb:42:in `<top (required)>'
    from /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj_mimic_json-1.0.1/lib/oj_mimic_json.rb:2:in `require'
    from /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/oj_mimic_json-1.0.1/lib/oj_mimic_json.rb:2:in `<top (required)>'
    from /usr/share/arachni/lib/arachni.rb:88:in `require'
    from /usr/share/arachni/lib/arachni.rb:88:in `<top (required)>'
    from /usr/share/arachni/ui/cli/framework.rb:9:in `require_relative'
    from /usr/share/arachni/ui/cli/framework.rb:9:in `<top (required)>'
    from ./arachni:10:in `require_relative'
    from ./arachni:10:in `<main>'
Steps To Reproduceapt-get install arachni
arachni -v
Additional Informationroot@kali:~# uname -a
Linux kali 4.9.0-kali3-686-pae 0000001 SMP Debian 4.9.16-1kali1 (2017-03-24) i686 GNU/Linux

root@kali:~# ruby -v
ruby 2.3.3p222 (2016-11-21) [i386-linux-gnu]

root@kali:~# dpkg -s arachni
Package: arachni
Status: install ok installed
Priority: extra
Section: non-free/net
Installed-Size: 99571
Maintainer: Mati Aharoni <muts@kali.org>
Architecture: all
Version: 1.5-0kali1
Depends: ruby | ruby-interpreter, bundler
Description: Web Application Security Scanner Framework
 Arachni is a feature-full, modular, high-performance Ruby framework aimed
 towards helping penetration testers and administrators evaluate the security
 of web applications.
Homepage: http://arachni-scanner.com/

root@kali:~# dpkg -s ruby-oj
Package: ruby-oj
Status: install ok installed
Priority: optional
Section: ruby
Installed-Size: 269
Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
Architecture: i386
Version: 2.17.4-1
Depends: ruby (>= 1:2.3~0), libc6 (>= 2.4), libgmp10, libruby2.3 (>= 2.3.0~preview2)
Suggests: ruby-activesupport
Description: fast JSON parser and serializer for Ruby
 JSON (or JavaScript Object Notation) is a text-based open standard designed
 for human-readable data interchange.
 .
 Oj (Optimized JSON) is a Ruby library written to provide speed optimized
 handling of JSON, for parsing JSON and serializing objects.
Homepage: http://www.ohler.com/oj
Ruby-Versions: ruby2.3

root@kali:~# dpkg -s ruby
Package: ruby
Status: install ok installed
Priority: optional
Section: ruby
Installed-Size: 38
Maintainer: Antonio Terceiro <terceiro@debian.org>
Architecture: i386
Multi-Arch: allowed
Source: ruby-defaults
Version: 1:2.3.3
Replaces: irb, rdoc, rubygems
Provides: irb, rdoc, rubygems
Depends: ruby2.3
Suggests: ri, ruby-dev
Breaks: apt-listbugs (<< 0.1.6), rbenv (<= 0.4.0-1), ruby-debian (<< 0.3.8+b3), ruby-switch (<= 0.1.0)
Conflicts: ruby-activesupport-2.3, ruby-activesupport-3.2
Description: Interpreter of object-oriented scripting language Ruby (default version)
 Ruby is the interpreted scripting language for quick and easy
 object-oriented programming. It has many features to process text
 files and to do system management tasks (as in perl). It is simple,
 straight-forward, and extensible.
 .
 This package is a dependency package, which depends on Debian's default Ruby
 version (currently v2.3).
Homepage: http://www.ruby-lang.org/

Attached Files

-Relationships
+Relationships

-Notes

~0006536

sbrun (manager)

fixed in new version 1.5-0kali3

~0006537

j-marz (reporter)

Thanks sbrun.

There are still issues with Arachni though...

After running arachni <url> , i receive the following error.

--------------------------------------------------------------------------------
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] [Selenium::WebDriver::Error::WebDriverError] Unable to find phantomjs executable.
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/phantomjs.rb:38:in `path'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser.rb:148:in `executable'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser.rb:142:in `has_executable?'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:50:in `host_has_browser?'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:65:in `use_browsers?'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:24:in `browser_cluster'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/audit.rb:173:in `audit'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework.rb:117:in `block in run'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/utilities.rb:425:in `exception_jail'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework.rb:117:in `run'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:428] /usr/share/arachni/ui/cli/framework.rb:80:in `block in run'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:429]
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:430] Parent:
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:431] Arachni::Framework
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:432]
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:433] Block:
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:434] #<Proc:0x828b52f4@/usr/share/arachni/lib/arachni/framework.rb:117>
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:435]
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:436] Caller:
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:437] /usr/share/arachni/lib/arachni/utilities.rb:425:in `exception_jail'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:437] /usr/share/arachni/lib/arachni/framework.rb:117:in `run'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:437] /usr/share/arachni/ui/cli/framework.rb:80:in `block in run'
[2017-03-28 19:36:22 +1100] [utilities#exception_jail:438] --------------------------------------------------------------------------------


I installed phantomjs using 'apt-get install phantomjs' and now arachni gets stuck initializing 6 browsers. See debug output below.


[*] Initializing...
 [*] Preparing plugins...
 [*] ... done.
 [*] BrowserCluster: Initializing 6 browsers...
 [2017-03-28 20:38:10 +1100 - 0.0] [!] [browser#spawn_phantomjs:1227] Worker: Spawning PhantomJS...
 [2017-03-28 20:38:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:39:10 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:39:10 +1100 - 0.0] [!] [browser_cluster/worker#shutdown:162] Worker: Shutting down (wait: true) ...
 [2017-03-28 20:39:10 +1100 - 0.0] [!] [browser#shutdown:378] Worker: Shutting down...
 [2017-03-28 20:39:10 +1100 - 0.0] [!] [browser#shutdown:401] Worker: ...shutdown complete.
 [2017-03-28 20:39:10 +1100 - 0.0] [!] [browser_cluster/worker#shutdown:195] Worker: ...shutdown complete.
 [2017-03-28 20:39:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:40:10 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:40:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:41:10 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:41:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:42:10 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:42:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:43:10 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:43:10 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:44:11 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:44:11 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:45:11 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:45:11 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:46:11 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:46:11 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...
 [2017-03-28 20:47:11 +1100 - 60.1] [!] [browser#spawn_phantomjs:1285] Worker: Spawn timed-out.
 [2017-03-28 20:47:11 +1100 - 0.0] [!] [browser#start_proxy:1318] Worker: Booting up...

~0006538

j-marz (reporter)

BrowserCluster timed out and led to this error:


--------------------------------------------------------------------------------
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] [Errno::ECONNREFUSED] Failed to open TCP connection to 127.0.0.1:10431 (Connection refused - connect(2) for "127.0.0.1" port 10431)
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:882:in `rescue in block in connect'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:879:in `block in connect'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/timeout.rb:91:in `block in timeout'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/timeout.rb:101:in `timeout'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:878:in `connect'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:863:in `do_start'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:852:in `start'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/net/http.rb:1398:in `request'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/http/default.rb:103:in `response_for'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/http/default.rb:57:in `request'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/http/common.rb:59:in `call'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/bridge.rb:653:in `raw_execute'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/bridge.rb:124:in `create_session'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/remote/bridge.rb:88:in `initialize'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/common/driver.rb:57:in `new'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver/common/driver.rb:57:in `for'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/vendor/bundle/ruby/2.3.0/gems/selenium-webdriver-3.0.1/lib/selenium/webdriver.rb:82:in `for'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser.rb:1109:in `selenium'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser.rb:1337:in `start_webdriver'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser.rb:187:in `initialize'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster/worker.rb:51:in `initialize'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster.rb:495:in `new'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster.rb:495:in `block in initialize_workers'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster.rb:494:in `times'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster.rb:494:in `initialize_workers'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/browser_cluster.rb:112:in `initialize'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:33:in `new'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:33:in `block in browser_cluster'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/lib/ruby/2.3.0/monitor.rb:214:in `mon_synchronize'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/browser.rb:28:in `browser_cluster'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework/parts/audit.rb:173:in `audit'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework.rb:117:in `block in run'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/utilities.rb:425:in `exception_jail'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/lib/arachni/framework.rb:117:in `run'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:428] /usr/share/arachni/ui/cli/framework.rb:80:in `block in run'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:429]
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:430] Parent:
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:431] Arachni::Framework
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:432]
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:433] Block:
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:434] #<Proc:0x81a8dbcc@/usr/share/arachni/lib/arachni/framework.rb:117>
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:435]
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:436] Caller:
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:437] /usr/share/arachni/lib/arachni/utilities.rb:425:in `exception_jail'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:437] /usr/share/arachni/lib/arachni/framework.rb:117:in `run'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:437] /usr/share/arachni/ui/cli/framework.rb:80:in `block in run'
[2017-03-28 20:48:11 +1100] [utilities#exception_jail:438] --------------------------------------------------------------------------------

~0006539

sbrun (manager)

Hi,
I will add phantomjs to the list of dependencies.

For the issue "arachni gets stuck initializing 6 browsers.", I can't reproduce this on a fresh install of Kali-rolling.
Could you try on a fresh install?

~0006550

j-marz (reporter)

Thanks for adding the dependency.

I determined the worker time-out issue only occurs when running arachni from headless cli (e.g. SSH).

Running from cli within Kali desktop works fine.

~0006578

sbrun (manager)

if you want to use ssh, you should try to run arachni with xvfb
+Notes

-Issue History
Date Modified Username Field Change
2017-03-26 04:04 j-marz New Issue
2017-03-28 07:14 sbrun Status new => resolved
2017-03-28 07:14 sbrun Resolution open => fixed
2017-03-28 07:14 sbrun Fixed in Version => 2017.1
2017-03-28 07:14 sbrun Note Added: 0006536
2017-03-28 09:48 j-marz Status resolved => feedback
2017-03-28 09:48 j-marz Resolution fixed => reopened
2017-03-28 09:48 j-marz Note Added: 0006537
2017-03-28 09:52 j-marz Note Added: 0006538
2017-03-28 09:52 j-marz Status feedback => new
2017-03-28 13:09 sbrun Note Added: 0006539
2017-04-02 05:58 j-marz Note Added: 0006550
2017-04-11 09:13 sbrun Status new => closed
2017-04-11 09:13 sbrun Resolution reopened => fixed
2017-04-11 09:13 sbrun Note Added: 0006578
+Issue History